// GPIOTE driver for nRF52840 | gat 11/04/23
#include "GPIOTE.h"
#include "nrf52840.h"
#include <stddef.h> // for NULL

static void dummy(void){}

void (*Event_Callbacks[8])(void) =
{dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy};

void GPIOTE_Setup(GPIOTE_Config cfg)
{
	NRF_GPIOTE->CONFIG[cfg.Channel] = (cfg.Mode) | ((cfg.Pin | (cfg.Port << 5U)) << 8U) | (cfg.Polarity << 16U);
	NRF_GPIOTE->INTENSET = 1U << cfg.Channel;
	if(cfg.Event_Callback != NULL) Event_Callbacks[cfg.Channel] = cfg.Event_Callback;
}

void GPIOTE_Setup_NO_IRQ(GPIOTE_Config cfg)
{
	NRF_GPIOTE->CONFIG[cfg.Channel] = (cfg.Mode) | ((cfg.Pin | (cfg.Port << 5U)) << 8U) | (cfg.Polarity << 16U);
}

void GPIOTE_IRQHandler(void)
{
	for(unsigned int i = 0; i < 8; i++)
	if(NRF_GPIOTE->EVENTS_IN[i])
	{
		NRF_GPIOTE->EVENTS_IN[i] = 0;
		Event_Callbacks[i]();
	}
}
