// PPI driver for nRF52840 | gat 26/04/23
#include "PPI.h"
#include "nrf52840.h"
#include "nrf52840_bitfields.h"

static unsigned int GetEventReg(PPI_Event ev)
{
	switch (ev)
	{
	default:
	case GPIOTE_EVENTS_IN_0:
		return (unsigned int)&NRF_GPIOTE->EVENTS_IN[0];
	}
}

static unsigned int GetTaskReg(PPI_Task ta)
{
	switch (ta)
	{
	default:
	case TIMER0_TASKS_COUNT:
		return (unsigned int)&NRF_TIMER0->TASKS_COUNT;
	}
}

void PPI_Configure_Channel(PPI_Config cfg)
{
	NRF_PPI->CH[cfg.channel_index].EEP = GetEventReg(cfg.event);
	NRF_PPI->CH[cfg.channel_index].TEP = GetTaskReg(cfg.task);
}

void PPI_Enable_Channel(unsigned int channel)
{
	NRF_PPI->CHENSET |= 1U << channel;
}

void PPI_Disable_Channel(unsigned int channel)
{
	NRF_PPI->CHENSET &= ~(1U << channel);
}
