// SPI Slave driver for nRF52840 | gat 26/04/23
#ifndef _SPIS_H_
#define _SPIS_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	SPIS0,
	SPIS1,
	SPIS2
}SPIS_Channel;

typedef enum
{
	SPIS_Leading=0,
	SPIS_Trailing=1
}SPIS_CPHA;

typedef enum
{
	SPIS_ActiveHigh=0,
	SPIS_ActiveLow=1
}SPIS_CPOL;

typedef enum
{
	SPIS_MSB_First=0,
	SPIS_LSB_First=1
}SPIS_Endian;

typedef struct
{
	SPIS_Channel Channel;
	SPIS_CPHA CPHA;
	SPIS_CPOL CPOL;
	SPIS_Endian Endian;
	unsigned int MOSI_Pin;
	unsigned int MOSI_Port;
	unsigned int MISO_Pin;
	unsigned int MISO_Port;
	unsigned int CLK_Pin;
	unsigned int CLK_Port;
	unsigned int CS_Pin;
	unsigned int CS_Port;
}SPIS_Config;

void SPIS_Setup(SPIS_Config cfg);
void SPIS_Rx_Callback_Register(SPIS_Channel ch, void (*Callback)(void));
void SPIS_Update(SPIS_Channel ch, void * tx_ptr, unsigned int tx_size, void * rx_ptr, unsigned int rx_size);
unsigned int SPIS_Get_Rxed_Count(SPIS_Channel ch);
void SPIS0_IRQ(void);

#ifdef __cplusplus
}
#endif

#endif //_SPIS_H_