// UART driver for nRF52840 | gat 11/04/23
#include "UART.h"
#include "nrf52840.h"

static NRF_UARTE_Type* GetReg(UART_Channel ch)
{
	switch(ch)
	{
		default:
		case UARTE0:
		return NRF_UARTE0;
		case UARTE1:
		return NRF_UARTE1;
	}
}

void UART_Setup(UART_Config cfg)
{
	NRF_UARTE_Type* reg = GetReg(cfg.Chann);
	reg->PSEL.TXD = cfg.Tx_Pin + (cfg.Tx_Port<<5U);
	reg->PSEL.RXD = cfg.Rx_Pin + (cfg.Rx_Port<<5U);
	reg->BAUDRATE = (unsigned int)cfg.Baud;
	reg->CONFIG = 0; // 8N1
	reg->ENABLE = 8;
}

void UARTE0_UART0_IRQHandler(void)
{  
	NRF_UARTE0->EVENTS_ENDRX = 0;
}

void UARTE1_IRQHandler(void)
{  
	NRF_UARTE1->EVENTS_ENDRX = 0;
}
